"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.has_animation_controller = exports.animation_controller_diagnose_implementation = void 0;
const Severity_1 = require("../../../Types/Severity");
const Animation_Controllers_1 = require("../../Minecraft/Animation Controllers");
/**
 *
 * @param id
 * @param data
 * @param diagnoser
 */
function animation_controller_diagnose_implementation(controllerId, user, ownerType, diagnoser) {
    if (has_animation_controller(controllerId, diagnoser)) {
        const controller = diagnoser.context.getCache().BehaviorPacks.animation_controllers.get(controllerId);
        if (!controller)
            return;
        (0, Animation_Controllers_1.general_animation_controllers_implementation)(controller, user, ownerType, diagnoser);
    }
}
exports.animation_controller_diagnose_implementation = animation_controller_diagnose_implementation;
/**
 *
 * @param id
 * @param diagnoser
 * @returns
 */
function has_animation_controller(id, diagnoser) {
    const cache = diagnoser.context.getCache();
    //Project has animation controller
    if (cache.BehaviorPacks.animation_controllers.has(id))
        return true;
    //Nothing then report error
    diagnoser.add(`"${id}"`, `Cannot find behaviorpack animation_controller: ${id}`, Severity_1.DiagnosticSeverity.error, "behaviorpack.animation_controller.missing");
    return false;
}
exports.has_animation_controller = has_animation_controller;
//# sourceMappingURL=diagnostics.js.map