"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BehaviorPack = void 0;
const BehaviorPack_1 = require("bc-minecraft-bedrock-project/lib/src/Lib/Project/BehaviorPack");
const Animation = __importStar(require("./Animation/entry"));
const AnimationController = __importStar(require("./Animation Controllers/entry"));
const Block = __importStar(require("./Block/entry"));
const Entity = __importStar(require("./Entity/entry"));
const Mcfunction = __importStar(require("./Mcfunction/entry"));
const Tick = __importStar(require("./Functions/Tick/entry"));
const Item = __importStar(require("./Item/entry"));
const LootTable = __importStar(require("./Loot Table/entry"));
const Manifest = __importStar(require("./Manifest/entry"));
const Script = __importStar(require("./Script/entry"));
const SpawnRule = __importStar(require("./Spawn Rule/entry"));
const Structure = __importStar(require("./Structure/entry"));
const Trading = __importStar(require("./Trading/entry"));
var BehaviorPack;
(function (BehaviorPack) {
    /**Processes and diagnoses the given textdocument
     * @param doc The document to process / diagnose
     * @param diagnoser The diagnoser to report to
     * @returns `true` or `false` whenever or not it was successful*/
    function Process(diagnoser) {
        const uri = diagnoser.document.uri;
        //retrieve filter doc type
        const type = BehaviorPack_1.FileType.detect(uri);
        switch (type) {
            case BehaviorPack_1.FileType.animation:
                Animation.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.animation_controller:
                AnimationController.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.block:
                Block.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.entity:
                Entity.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.function:
                if (uri.endsWith("tick.json")) {
                    Tick.Diagnose(diagnoser);
                }
                else {
                    Mcfunction.Diagnose(diagnoser);
                }
                break;
            case BehaviorPack_1.FileType.item:
                Item.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.loot_table:
                LootTable.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.manifest:
                Manifest.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.script:
                Script.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.spawn_rule:
                SpawnRule.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.structure:
                Structure.Diagnose(diagnoser);
                break;
            case BehaviorPack_1.FileType.trading:
                Trading.Diagnose(diagnoser);
                break;
            default:
            case BehaviorPack_1.FileType.unknown:
                return false;
        }
        return true;
    }
    BehaviorPack.Process = Process;
})(BehaviorPack || (exports.BehaviorPack = BehaviorPack = {}));
//# sourceMappingURL=BehaviorPack.js.map