"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const diagnose_1 = require("./components/diagnose");
const diagnostics_1 = require("../../Molang/diagnostics");
const bc_minecraft_bedrock_project_1 = require("bc-minecraft-bedrock-project");
const components_1 = require("bc-minecraft-bedrock-types/lib/src/minecraft/components");
const Json_1 = require("../../Json");
const dependencies_1 = require("./components/dependencies");
/**Diagnoses the given document as an bp block
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    var _a, _b, _c, _d;
    //Check molang
    (0, diagnostics_1.diagnose_molang)(diagnoser.document.getText(), "Blocks", diagnoser);
    const block = Json_1.Json.LoadReport(diagnoser);
    if (!bc_minecraft_bedrock_project_1.Internal.BehaviorPack.Block.is(block))
        return;
    //check components
    const context = {
        components: (0, components_1.getUsedComponents)(block["minecraft:block"]),
    };
    (_b = (_a = block["minecraft:block"]) === null || _a === void 0 ? void 0 : _a.permutations) === null || _b === void 0 ? void 0 : _b.forEach((p) => {
        context.components.push(...(0, components_1.getUsedComponents)(p));
    });
    (0, diagnose_1.behaviorpack_diagnose_block_components)(block["minecraft:block"], context, diagnoser);
    (_d = (_c = block["minecraft:block"]) === null || _c === void 0 ? void 0 : _c.permutations) === null || _d === void 0 ? void 0 : _d.forEach((p) => {
        (0, diagnose_1.behaviorpack_diagnose_block_components)(p, context, diagnoser);
    });
    (0, dependencies_1.behaviorpack_block_components_dependencies)(block, context, diagnoser);
}
exports.Diagnose = Diagnose;
//# sourceMappingURL=entry.js.map