"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const Severity_1 = require("../../../../Types/Severity");
const Json_1 = require("../../../Json/Json");
/**Diagnoses the given document as an tick.json
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    var _a;
    const data = Json_1.Json.LoadReport(diagnoser);
    if (!data || !data.values)
        return;
    const pack = diagnoser.context.getCache().BehaviorPacks.get(diagnoser.document.uri);
    if (!pack)
        return;
    //Specific lookup in the pack
    (_a = data.values) === null || _a === void 0 ? void 0 : _a.forEach((path) => {
        if (!pack.functions.has(path)) {
            diagnoser.add(path, "Cannot find mcfunction: " + path, Severity_1.DiagnosticSeverity.error, "behaviorpack.mcfunction.missing");
        }
    });
}
exports.Diagnose = Diagnose;
//# sourceMappingURL=entry.js.map