"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const Json_1 = require("../../Json/Json");
const diagnose_1 = require("../Item/diagnose");
const diagnose_2 = require("./diagnose");
const functions_1 = require("./functions");
const Items_1 = require("../../Minecraft/Items");
/**Diagnoses the given document as an loot table
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    var _a;
    const table = Json_1.Json.LoadReport(diagnoser);
    if (typeof table !== "object")
        return;
    (_a = table.pools) === null || _a === void 0 ? void 0 : _a.forEach((pool) => {
        var _a;
        (_a = pool.entries) === null || _a === void 0 ? void 0 : _a.forEach((entry) => {
            var _a;
            //Is item then check if item exists
            switch (entry.type) {
                case "item":
                    if (entry.name)
                        (0, diagnose_1.behaviorpack_item_diagnose)((0, Items_1.minecraft_get_item)(entry.name, diagnoser.document), diagnoser);
                    break;
                case "loot_table":
                    if (entry.name)
                        (0, diagnose_2.behaviorpack_loot_table_diagnose)((0, Items_1.minecraft_get_item)(entry.name, diagnoser.document), diagnoser);
                    break;
            }
            //Loop over functions
            (_a = entry.functions) === null || _a === void 0 ? void 0 : _a.forEach((fn) => (0, functions_1.behaviorpack_loot_table_function_diagnose)(fn, diagnoser));
        });
    });
}
exports.Diagnose = Diagnose;
//# sourceMappingURL=entry.js.map