"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.behaviorpack_functions_diagnose = void 0;
const bc_minecraft_bedrock_project_1 = require("bc-minecraft-bedrock-project");
const Types_1 = require("../../../Types");
const Definitions_1 = require("../../Definitions");
function behaviorpack_functions_diagnose(value, diagnoser) {
    const data = diagnoser.context.getCache();
    const id = bc_minecraft_bedrock_project_1.Text.UnQuote(value.text);
    //Check project
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.function, id, diagnoser))
        return true;
    //If project has function then ignore
    if (data.BehaviorPacks.functions.has(id))
        return true;
    diagnoser.add(value.offset, `Cannot find mcfunction: ${id}`, Types_1.DiagnosticSeverity.error, "behaviorpack.mcfunction.missing");
    return false;
}
exports.behaviorpack_functions_diagnose = behaviorpack_functions_diagnose;
//# sourceMappingURL=diagnose.js.map