"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.behaviorpack_structure_diagnose = void 0;
const Types_1 = require("../../../Types");
const Definitions_1 = require("../../Definitions");
function behaviorpack_structure_diagnose(value, diagnoser) {
    const id = value.text;
    //If it has a slash it needs ""
    if (id.includes("/")) {
        if (id.startsWith('"') && id.endsWith('"')) {
        }
        else {
            diagnoser.add(value, `A structure id with '/' needs quotes surrounding it: ${id} => "${id}"`, Types_1.DiagnosticSeverity.error, "behaviorpack.mcstructure.invalid");
        }
    }
    //Defined in McProject
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.structure, id, diagnoser))
        return true;
    const data = diagnoser.context.getCache();
    //Project has structure
    if (data.BehaviorPacks.structures.has(id))
        return true;
    if (data.General.structures.has(id))
        return true;
    //structures can be identified with : or /
    if (id.includes(":")) {
        const cid = id.replace(":", "/");
        if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.structure, cid, diagnoser))
            return true;
        if (data.BehaviorPacks.structures.has(cid))
            return true;
        if (data.General.structures.has(cid))
            return true;
    }
    //Nothing then report error
    diagnoser.add(value, `Cannot find behaviorpack mcstructure: ${id}`, Types_1.DiagnosticSeverity.error, "behaviorpack.mcstructure.missing");
    return false;
}
exports.behaviorpack_structure_diagnose = behaviorpack_structure_diagnose;
//# sourceMappingURL=diagnose.js.map