"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.behaviorpack_trading_diagnose = void 0;
const Types_1 = require("../../../Types");
const Definitions_1 = require("../../Definitions");
const bc_minecraft_bedrock_vanilla_data_1 = require("bc-minecraft-bedrock-vanilla-data");
function behaviorpack_trading_diagnose(value, diagnoser) {
    const id = typeof value === "string" ? value : value.text;
    //Defined in McProject
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.trading, id, diagnoser))
        return true;
    const data = diagnoser.context.getCache();
    //Project has loot_table
    if (data.BehaviorPacks.trading.has(id))
        return true;
    const edu = (0, Definitions_1.education_enabled)(diagnoser);
    //Vanilla has loot_table
    if (bc_minecraft_bedrock_vanilla_data_1.MinecraftData.BehaviorPack.hasTrading(id, edu))
        return true;
    //Nothing then report error
    diagnoser.add(value, `Cannot find behaviorpack trading definition: ${id}`, Types_1.DiagnosticSeverity.error, "behaviorpack.trading.missing");
    return false;
}
exports.behaviorpack_trading_diagnose = behaviorpack_trading_diagnose;
//# sourceMappingURL=diagnose.js.map