"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const Json_1 = require("../../Json/Json");
const functions_1 = require("../Loot Table/functions");
const diagnose_1 = require("../Item/diagnose");
const Items_1 = require("../../Minecraft/Items");
/**Diagnoses the given document as an trading table
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    var _a;
    const table = Json_1.Json.LoadReport(diagnoser);
    if (typeof table !== "object")
        return;
    //Foreach tier
    (_a = table.tiers) === null || _a === void 0 ? void 0 : _a.forEach((tier) => {
        var _a;
        //Foreach group in tier
        (_a = tier.groups) === null || _a === void 0 ? void 0 : _a.forEach((group) => {
            var _a;
            //Foreach trade in group
            (_a = group.trades) === null || _a === void 0 ? void 0 : _a.forEach((trade) => {
                var _a, _b;
                //Foreach gives in group
                (_a = trade.gives) === null || _a === void 0 ? void 0 : _a.forEach((item) => diagnose_item(item, diagnoser));
                //Foreach want in group
                (_b = trade.wants) === null || _b === void 0 ? void 0 : _b.forEach((item) => diagnose_item(item, diagnoser));
            });
        });
    });
}
exports.Diagnose = Diagnose;
function diagnose_item(entry, diagnoser) {
    var _a;
    //Is item then check if item exists
    if (entry.item)
        (0, diagnose_1.behaviorpack_item_diagnose)((0, Items_1.minecraft_get_item)(entry.item, diagnoser.document), diagnoser);
    (_a = entry.functions) === null || _a === void 0 ? void 0 : _a.forEach((fn) => (0, functions_1.behaviorpack_loot_table_function_diagnose)(fn, diagnoser));
}
//# sourceMappingURL=entry.js.map