import { DiagnosticsBuilder } from "../../Types/DiagnosticsBuilder";
import { EntityAnimationMolangCarrier, EventCarrier } from "../../Types/Interfaces";
import { MolangDataSetKey } from "bc-minecraft-molang";
/**
 * @param id
 * @param user
 * @param ownerType
 * @param diagnoser
 * @returns
 */
export declare function animation_or_controller_diagnose_implementation(id: string, user: EntityAnimationMolangCarrier & EventCarrier, ownerType: MolangDataSetKey, diagnoser: DiagnosticsBuilder): void;
/** The result of the animation or controller check */
export declare enum anim_or_contr {
    /** the id is an animation */
    animation = 0,
    /** the id is an animation controller */
    controller = 1,
    /** the id is neither an animation nor an animation controller */
    neither = 2
}
/** is an animation or controller.
 * @param id The id of the animation or controller
 * @param diagnoser The diagnostics builder to add the errors to
 * @returns True if animation, false if controller*/
export declare function is_animation_or_controller(id: string, diagnoser: DiagnosticsBuilder): anim_or_contr;
