"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Handle_Json_Error = void 0;
const main_1 = require("../../../main");
function Handle_Json_Error(err, diagnoser) {
    if (typeof err.message !== "string") {
        diagnoser.add(0, "Invalid json structure\nmessage:" + JSON.stringify(err), main_1.DiagnosticSeverity.error, "json.invalid");
    }
    const message = err.message;
    let word = {
        offset: 0,
        text: " ",
    };
    const token = safe_first_get(/token ([^ ]+) /gim, message);
    if (token)
        word.text = token;
    const pos = safe_first_get(/position (\d+)/gim, message);
    if (pos)
        word.offset = Number.parseInt(pos);
    diagnoser.add(word, message, main_1.DiagnosticSeverity.error, "json.invalid");
}
exports.Handle_Json_Error = Handle_Json_Error;
function safe_first_get(regex, text) {
    var _a;
    const match = regex.exec(text);
    if (match)
        return (_a = match[1]) !== null && _a !== void 0 ? _a : match[0];
    return undefined;
}
//# sourceMappingURL=Errors.js.map