"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minecraft_animation_used = void 0;
const bc_minecraft_bedrock_types_1 = require("bc-minecraft-bedrock-types");
const Severity_1 = require("../../Types/Severity");
function minecraft_animation_used(animations, diagnoser, controllers, script) {
    const used = [];
    if (script) {
        bc_minecraft_bedrock_types_1.Types.Conditional.forEach(script.animate, (ref, condition) => used.push(ref));
    }
    //Extract animations from controllers
    bc_minecraft_bedrock_types_1.Types.Definition.forEach(animations, (ref, id) => {
        const controller = controllers.get(id);
        //If it is a controller, then add used animations
        if (controller) {
            used.push(...controller.animations.using);
        }
    });
    //
    bc_minecraft_bedrock_types_1.Types.Definition.forEach(animations, (ref, id) => {
        //If the used animations does not contain the referenced animation, then its unused
        if (!used.includes(ref)) {
            diagnoser.add(`${ref}/${id}`, `Animation: ${id} is not being used, could be removed`, Severity_1.DiagnosticSeverity.info, `minecraft.animation.unused`);
        }
    });
}
exports.minecraft_animation_used = minecraft_animation_used;
//# sourceMappingURL=Animation.js.map