"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minecraft_diagnose_filter = exports.minecraft_diagnose_filters = void 0;
const bc_minecraft_bedrock_types_1 = require("bc-minecraft-bedrock-types");
const is_family_1 = require("./Filters/is_family");
const has_tag_1 = require("./Filters/has_tag");
const property_1 = require("./Filters/property");
function minecraft_diagnose_filters(value, diagnoser) {
    if (typeof value !== "object")
        return;
    bc_minecraft_bedrock_types_1.Minecraft.Filter.Filter.forEach(value, (filter) => minecraft_diagnose_filter(filter, diagnoser));
}
exports.minecraft_diagnose_filters = minecraft_diagnose_filters;
function minecraft_diagnose_filter(value, diagnoser) {
    const callFn = FilterDiagnose[value.test];
    if (callFn) {
        callFn(value, diagnoser);
    }
}
exports.minecraft_diagnose_filter = minecraft_diagnose_filter;
const FilterDiagnose = {
    is_family: is_family_1.diagnose_filter_is_family,
    has_tag: has_tag_1.diagnose_filter_has_tag,
    //Properties
    int_property: property_1.diagnose_filter_property,
    bool_property: property_1.diagnose_filter_property,
    float_property: property_1.diagnose_filter_property,
    enum_property: property_1.diagnose_filter_property,
    has_property: property_1.diagnose_filter_property,
};
//# sourceMappingURL=diagnose.js.map