"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.minecraft_objectives_diagnose = void 0;
const Types_1 = require("../../Types");
const Definitions_1 = require("../Definitions");
function minecraft_objectives_diagnose(value, diagnoser) {
    if (diagnoser.project.attributes["diagnostic.objective"] === "false") {
        return true;
    }
    //Length check
    const id = value.text;
    if (!/^[a-zA-Z0-9\-\_\.:]+$/gim.test(id)) {
        diagnoser.add(value, `Illegal character found in objective: '${id}'.`, Types_1.DiagnosticSeverity.error, "minecraft.objective.invalid");
    }
    //Defined in McProject
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.objective, id, diagnoser)) {
        return true;
    }
    //Project has defined
    const data = diagnoser.context.getCache();
    if (data.General.objectives.has(id)) {
        return true;
    }
    //Nothing then report error
    diagnoser.add(value, `Cannot find objective definition: ${id}`, Types_1.DiagnosticSeverity.error, "minecraft.objective.missing");
    return false;
}
exports.minecraft_objectives_diagnose = minecraft_objectives_diagnose;
//# sourceMappingURL=Objective.js.map