"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.must_offset_word = exports.forEach = exports.all = void 0;
const json_1 = require("bc-minecraft-bedrock-types/lib/src/minecraft/json");
const Types_1 = require("../../../Types");
/**
 *
 * @param fn
 * @returns
 */
function all(...fn) {
    return (attr, sel, diagnoser) => {
        let result = true;
        for (const f of fn) {
            result = result && f(attr, sel, diagnoser);
        }
        return result;
    };
}
exports.all = all;
function forEach(fn) {
    return (attr, sel, diagnoser) => {
        let result = true;
        for (const a of attr) {
            result = result && fn(a, sel, diagnoser);
        }
        return result;
    };
}
exports.forEach = forEach;
function must_offset_word(fn) {
    return forEach((attr, sel, diagnoser) => {
        if (json_1.CompactJson.isString(attr)) {
            const word = json_1.CompactJson.valueToOffsetWord(attr);
            if (word.text.startsWith("!")) {
                word.text = word.text.slice(1);
                word.offset++;
            }
            return fn(word, diagnoser);
        }
        diagnoser.add(json_1.CompactJson.valueToOffsetWord(attr), "Expected a string", Types_1.DiagnosticSeverity.error, "minecraft.selector.attribute.string");
        return false;
    });
}
exports.must_offset_word = must_offset_word;
//# sourceMappingURL=Util.js.map