"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.mode_time_diagnose = exports.mode_teleportrules_diagnose = exports.mode_structureanimation_diagnose = exports.mode_slotid_diagnose = exports.mode_slottype_diagnose = exports.mode_selectortype_diagnose = exports.mode_selectorattribute_diagnose = exports.mode_save_diagnose = exports.mode_rotation_diagnose = exports.mode_riderules_diagnose = exports.mode_ridefill_diagnose = exports.mode_replace_diagnose = exports.mode_permissionState_diagnose = exports.mode_permission_diagnose = exports.mode_operation_diagnose = exports.mode_oldblock_diagnose = exports.mode_musicrepeat_diagnose = exports.mode_mirror_diagnose = exports.mode_mask_diagnose = exports.mode_handtype_diagnose = exports.mode_locatefeature_diagnose = exports.mode_gamemode_diagnose = exports.mode_fill_diagnose = exports.mode_difficulty_diagnose = exports.mode_clone_diagnose = exports.mode_causetype_diagnose = exports.mode_camerashake_diagnose = void 0;
const bc_minecraft_bedrock_types_1 = require("bc-minecraft-bedrock-types");
const Severity_1 = require("../../Types/Severity");
const Definitions_1 = require("../Definitions");
/**Diagnoses the value as a value in the mode: camerashake
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_camerashake_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.CameraShake, diagnoser);
}
exports.mode_camerashake_diagnose = mode_camerashake_diagnose;
/**Diagnoses the value as a value in the mode: camerashake
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_causetype_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.CauseType, diagnoser);
}
exports.mode_causetype_diagnose = mode_causetype_diagnose;
/**Diagnoses the value as a value in the mode: clone
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_clone_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Clone, diagnoser);
}
exports.mode_clone_diagnose = mode_clone_diagnose;
/**Diagnoses the value as a value in the mode: difficulty
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_difficulty_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Difficulty, diagnoser);
}
exports.mode_difficulty_diagnose = mode_difficulty_diagnose;
/**Diagnoses the value as a value in the mode: fill
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_fill_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Fill, diagnoser);
}
exports.mode_fill_diagnose = mode_fill_diagnose;
/**Diagnoses the value as a value in the mode: gamemode
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_gamemode_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Gamemode, diagnoser);
}
exports.mode_gamemode_diagnose = mode_gamemode_diagnose;
/**Diagnoses the value as a value in the mode: locatefeature
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_locatefeature_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.LocateFeature, diagnoser);
}
exports.mode_locatefeature_diagnose = mode_locatefeature_diagnose;
/**Diagnoses the value as a value in the mode: locatefeature
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_handtype_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.HandType, diagnoser);
}
exports.mode_handtype_diagnose = mode_handtype_diagnose;
/**Diagnoses the value as a value in the mode: mask
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_mask_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Mask, diagnoser);
}
exports.mode_mask_diagnose = mode_mask_diagnose;
/**Diagnoses the value as a value in the mode: mirror
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_mirror_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Mirror, diagnoser);
}
exports.mode_mirror_diagnose = mode_mirror_diagnose;
/**Diagnoses the value as a value in the mode: musicrepeat
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_musicrepeat_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.MusicRepeat, diagnoser);
}
exports.mode_musicrepeat_diagnose = mode_musicrepeat_diagnose;
/**Diagnoses the value as a value in the mode: oldblock
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_oldblock_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.OldBlock, diagnoser);
}
exports.mode_oldblock_diagnose = mode_oldblock_diagnose;
/**Diagnoses the value as a value in the mode: operation
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_operation_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Operation, diagnoser);
}
exports.mode_operation_diagnose = mode_operation_diagnose;
/**Diagnoses the value as a value in the mode: permission
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_permission_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Permission, diagnoser);
}
exports.mode_permission_diagnose = mode_permission_diagnose;
/**Diagnoses the value as a value in the mode: permissionState
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_permissionState_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.PermissionState, diagnoser);
}
exports.mode_permissionState_diagnose = mode_permissionState_diagnose;
/**Diagnoses the value as a value in the mode: replace
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_replace_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Replace, diagnoser);
}
exports.mode_replace_diagnose = mode_replace_diagnose;
/**Diagnoses the value as a value in the mode: ridefill
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_ridefill_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.RideFill, diagnoser);
}
exports.mode_ridefill_diagnose = mode_ridefill_diagnose;
/**Diagnoses the value as a value in the mode: riderules
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_riderules_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.RideRules, diagnoser);
}
exports.mode_riderules_diagnose = mode_riderules_diagnose;
/**Diagnoses the value as a value in the mode: rotation
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_rotation_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Rotation, diagnoser);
}
exports.mode_rotation_diagnose = mode_rotation_diagnose;
/**Diagnoses the value as a value in the mode: save
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_save_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Save, diagnoser);
}
exports.mode_save_diagnose = mode_save_diagnose;
/**Diagnoses the value as a value in the mode: selectorattribute
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_selectorattribute_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.SelectorAttribute, diagnoser);
}
exports.mode_selectorattribute_diagnose = mode_selectorattribute_diagnose;
/**Diagnoses the value as a value in the mode: selectortype
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_selectortype_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.SelectorType, diagnoser);
}
exports.mode_selectortype_diagnose = mode_selectortype_diagnose;
/**Diagnoses the value as a value in the mode: slottype
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_slottype_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.SlotType, diagnoser);
}
exports.mode_slottype_diagnose = mode_slottype_diagnose;
/**Diagnoses the value as a value in the mode: slotid
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_slotid_diagnose(value, Com, diagnoser) {
    if (typeof Com !== "string") {
        //Get the slot type
        const index = Com.parameters.indexOf(value) - 1;
        //if the index is negative, the parameter then was not found
        if (index < 0)
            return false;
        Com = Com.parameters[index].text;
    }
    //Get the slot type
    const m = bc_minecraft_bedrock_types_1.Modes.SlotType.get(Com);
    //if the mode is not found, then the parameter is not valid, expected that the previous parameter handling handled slot type not existing
    if (m === undefined)
        return false;
    if (m.eduOnly === true && (0, Definitions_1.education_enabled)(diagnoser) === false) {
        diagnoser.add(value.offset, "This is an education only mode, and education is disabled", Severity_1.DiagnosticSeverity.error, "minecraft.mode.edu");
        return false;
    }
    if (m.range) {
        const n = Number.parseInt(value.text);
        if (n < m.range.min || n > m.range.max) {
            diagnoser.add(value.offset, `The value is ${n} not in the range of ${m.range.min} to ${m.range.max}`, Severity_1.DiagnosticSeverity.error, "minecraft.mode.range");
            return false;
        }
    }
    return true;
}
exports.mode_slotid_diagnose = mode_slotid_diagnose;
/**Diagnoses the value as a value in the mode: structureanimation
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_structureanimation_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.StructureAnimation, diagnoser);
}
exports.mode_structureanimation_diagnose = mode_structureanimation_diagnose;
/**Diagnoses the value as a value in the mode: teleportrules
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_teleportrules_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.TeleportRules, diagnoser);
}
exports.mode_teleportrules_diagnose = mode_teleportrules_diagnose;
/**Diagnoses the value as a value in the mode: time
 * @param value The value to evaluate, needs the offset to report bugs
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_time_diagnose(value, diagnoser) {
    return mode_generic_diagnose(value, bc_minecraft_bedrock_types_1.Modes.Time, diagnoser);
}
exports.mode_time_diagnose = mode_time_diagnose;
/**Diagnoses the value a generic collection of modes
 * @param value The value to evaluate, needs the offset to report bugs
 * @param Mode The collection of values to check against
 * @param diagnoser The diagnoser to report to
 * @returns true or false, false is any error was found*/
function mode_generic_diagnose(value, Mode, diagnoser) {
    const m = Mode.get(value.text);
    //Mode returned then it is valid
    if (m)
        return true;
    const name = Mode.name.toLowerCase();
    diagnoser.add(value, `value: '${value.text}' is not defined in mode: '${name}'`, Severity_1.DiagnosticSeverity.error, `minecraft.mode.${name}.invalid`);
    return false;
}
//# sourceMappingURL=diagnose.js.map