"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.check_geo_and_rules = void 0;
const Types_1 = require("../../../Types");
function check_geo_and_rules(geoId, culling, diagnoser) {
    const projectData = diagnoser.context.getCache();
    const model = projectData.ResourcePacks.models.get(geoId);
    if (!model)
        return;
    const cullingRule = projectData.ResourcePacks.block_culling_rules.get(culling);
    if (!cullingRule)
        return;
    for (var i = 0; i < cullingRule.affected_bones.length; i++) {
        const bone = cullingRule.affected_bones[i];
        if (model.bones.includes(bone))
            continue;
        diagnoser.add(culling, `The geometry '${geoId}' does not contain the bone '${bone}' as defined in the culling rule '${culling}'`, Types_1.DiagnosticSeverity.warning, "resourcepack.block_culling.missing_bone");
    }
}
exports.check_geo_and_rules = check_geo_and_rules;
//# sourceMappingURL=diagnostics.js.map