"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resourcepack_check_entityid = void 0;
const bc_minecraft_bedrock_vanilla_data_1 = require("bc-minecraft-bedrock-vanilla-data");
const Severity_1 = require("../../../Types/Severity");
const Definitions_1 = require("../../Definitions");
function resourcepack_check_entityid(id, diagnoser) {
    //Defined in McProject
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.entity, id, diagnoser))
        return;
    const data = diagnoser.context.getCache();
    //Project has entity
    if (data.hasEntity(id))
        return;
    const edu = (0, Definitions_1.education_enabled)(diagnoser);
    //Vanilla has entity
    if (bc_minecraft_bedrock_vanilla_data_1.MinecraftData.ResourcePack.hasEntity(id, edu))
        return;
    //Nothing then report error
    diagnoser.add(id, `Cannot find entity definition: ${id}`, Severity_1.DiagnosticSeverity.error, "resourcepack.entity.missing");
}
exports.resourcepack_check_entityid = resourcepack_check_entityid;
//# sourceMappingURL=check.js.map