"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.checkBonesExists = void 0;
const Types_1 = require("../../../Types");
function checkBonesExists(bones, diagnoser) {
    const projectData = diagnoser.context.getCache();
    for (let I = 0; I < bones.length; I++) {
        const bone = bones[I];
        if (bone.bone_id.includes('*'))
            continue;
        // Find a bone that is not in the project
        if (!projectData.ResourcePacks.models.find((m) => { var _a; return (_a = m.bones) === null || _a === void 0 ? void 0 : _a.includes(bone.bone_id); })) {
            diagnoser.add(`${bone.parent_id}/${bone.bone_id}`, `Bone: ${bone.bone_id} does not exist in the project, though animation can work with missing bones`, Types_1.DiagnosticSeverity.warning, `resourcepack.model.bone.missing`);
        }
    }
}
exports.checkBonesExists = checkBonesExists;
//# sourceMappingURL=bones.js.map