"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resourcepack_has_model = void 0;
const bc_minecraft_bedrock_vanilla_data_1 = require("bc-minecraft-bedrock-vanilla-data");
const Severity_1 = require("../../../Types/Severity");
const Definitions_1 = require("../../Definitions");
function resourcepack_has_model(modelId, diagnoser) {
    const data = diagnoser.context.getCache();
    //Has project data
    if (data.ResourcePacks.models.has(modelId))
        return true;
    const edu = (0, Definitions_1.education_enabled)(diagnoser);
    //Check vanilla data
    if (bc_minecraft_bedrock_vanilla_data_1.MinecraftData.ResourcePack.hasModel(modelId, edu))
        return true;
    diagnoser.add(modelId, `Cannot find model definition: ${modelId}`, Severity_1.DiagnosticSeverity.error, "resourcepack.model.missing");
    return false;
}
exports.resourcepack_has_model = resourcepack_has_model;
//# sourceMappingURL=diagnose.js.map