"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.resourcepack_particle_diagnose = void 0;
const bc_minecraft_bedrock_vanilla_data_1 = require("bc-minecraft-bedrock-vanilla-data");
const main_1 = require("../../../../main");
const Definitions_1 = require("../../Definitions");
function resourcepack_particle_diagnose(id, diagnoser) {
    const particle_id = typeof id === "string" ? id : id.text;
    //Defined in McProject
    if ((0, Definitions_1.check_definition_value)(diagnoser.project.definitions.particle, particle_id, diagnoser))
        return;
    const data = diagnoser.context.getCache();
    //Project has entity
    if (data.ResourcePacks.particles.has(particle_id))
        return;
    const edu = (0, Definitions_1.education_enabled)(diagnoser);
    //Vanilla has entity
    if (bc_minecraft_bedrock_vanilla_data_1.MinecraftData.ResourcePack.hasParticle(particle_id, edu))
        return;
    //Nothing then report error
    diagnoser.add("particle/" + id, `Cannot find particle definition: ${particle_id}`, main_1.DiagnosticSeverity.error, "resourcepack.particle.missing");
}
exports.resourcepack_particle_diagnose = resourcepack_particle_diagnose;
//# sourceMappingURL=diagnose.js.map