"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.has_render_controller = exports.render_controller_diagnose_implementation = void 0;
const bc_minecraft_bedrock_vanilla_data_1 = require("bc-minecraft-bedrock-vanilla-data");
const Severity_1 = require("../../../Types/Severity");
const Definitions_1 = require("../../Definitions");
const diagnostics_1 = require("../../Molang/diagnostics");
/**
 *
 * @param id
 * @param data
 * @param diagnoser
 */
function render_controller_diagnose_implementation(controllerId, user, ownerType, diagnoser) {
    if (has_render_controller(controllerId, diagnoser)) {
        const cache = diagnoser.context.getCache();
        //Project has render controller
        const rp = cache.ResourcePacks.render_controllers.get(controllerId);
        if (!rp)
            return;
        (0, diagnostics_1.diagnose_molang_implementation)(rp, user, ownerType, diagnoser);
    }
}
exports.render_controller_diagnose_implementation = render_controller_diagnose_implementation;
/**
 *
 * @param id
 * @param diagnoser
 * @returns
 */
function has_render_controller(id, diagnoser) {
    const cache = diagnoser.context.getCache();
    //Project has render controller
    if (cache.ResourcePacks.render_controllers.has(id))
        return true;
    const edu = (0, Definitions_1.education_enabled)(diagnoser);
    //Vanilla has render controller
    if (bc_minecraft_bedrock_vanilla_data_1.MinecraftData.ResourcePack.hasRenderController(id, edu))
        return true;
    //Nothing then report error
    diagnoser.add(id, `Cannot find render controller: ${id}`, Severity_1.DiagnosticSeverity.error, "resourcepack.render_controller.missing");
    return false;
}
exports.has_render_controller = has_render_controller;
//# sourceMappingURL=diagnostics.js.map