"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const bc_minecraft_bedrock_project_1 = require("bc-minecraft-bedrock-project");
const diagnostics_1 = require("../../Molang/diagnostics");
const bc_minecraft_bedrock_project_2 = require("bc-minecraft-bedrock-project");
const Json_1 = require("../../Json");
const Model_1 = require("../Model");
/**Diagnoses the given document as a render controller
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    //Check molang
    (0, diagnostics_1.diagnose_molang)(diagnoser.document.getText(), "RenderControllers", diagnoser);
    //Load model
    const model = Json_1.Json.LoadReport(diagnoser);
    if (!bc_minecraft_bedrock_project_2.Internal.ResourcePack.RenderControllers.is(model))
        return;
    const bones = [];
    bc_minecraft_bedrock_project_1.SMap.forEach(model.render_controllers, (controller, id) => {
        var _a;
        (_a = controller.part_visibility) === null || _a === void 0 ? void 0 : _a.forEach((v) => {
            const key = Object.keys(v)[0];
            if (key)
                return;
            bones.push({ bone_id: key, parent_id: id });
        });
    });
    (0, Model_1.checkBonesExists)(bones, diagnoser);
}
exports.Diagnose = Diagnose;
//# sourceMappingURL=entry.js.map