"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ResourcePack = void 0;
const bc_minecraft_bedrock_project_1 = require("bc-minecraft-bedrock-project");
const Animation = __importStar(require("./Animation/entry"));
const AnimationController = __importStar(require("./Animation Controllers/entry"));
const Attachable = __importStar(require("./Attachable/entry"));
const BlockCulling = __importStar(require("./BlockCulling/entry"));
const BiomesClient = __importStar(require("./Biomes Client/entry"));
const Block = __importStar(require("./Block/entry"));
const Blocks = __importStar(require("./Block/entry"));
const Entity = __importStar(require("./Entity/entry"));
const Fog = __importStar(require("./Fog/entry"));
const Item = __importStar(require("./Item/entry"));
const Manifest = __importStar(require("./Manifest/entry"));
const Material = __importStar(require("./Material/entry"));
const Model = __importStar(require("./Model/entry"));
const MusicDefinitions = __importStar(require("./Music Definitions/entry"));
const Particle = __importStar(require("./Particle/entry"));
const RenderController = __importStar(require("./Render Controller/entry"));
const Sounds = __importStar(require("./Sounds/entry"));
const SoundsDefinitions = __importStar(require("./Sounds Definitions/entry"));
const Texture = __importStar(require("./Texture/entry"));
const TextureAtlas = __importStar(require("./Texture Atlas/entry"));
const Flipbook = __importStar(require("./Texture Atlas/flipbook"));
/** The namespace that deals with resourcepack diagnostics */
var ResourcePack;
(function (ResourcePack) {
    /** Processes and diagnoses the given textdocument
     * @param doc The document to process / diagnose
     * @param diagnoser The diagnoser to report to
     * @returns `true` or `false` whenever or not it was succesfull */
    function Process(diagnoser) {
        const uri = diagnoser.document.uri;
        const type = bc_minecraft_bedrock_project_1.ResourcePack.FileType.detect(uri);
        switch (type) {
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.animation:
                Animation.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.animation_controller:
                AnimationController.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.attachable:
                Attachable.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.block_culling_rules:
                BlockCulling.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.biomes_client:
                BiomesClient.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.block:
                if (uri.endsWith("blocks.json")) {
                    Blocks.Diagnose(diagnoser);
                }
                else {
                    Block.Diagnose(diagnoser);
                }
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.entity:
                Entity.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.fog:
                Fog.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.item:
                Item.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.manifest:
                Manifest.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.material:
                Material.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.model:
                Model.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.music_definitions:
                MusicDefinitions.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.particle:
                Particle.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.render_controller:
                RenderController.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.sounds:
                Sounds.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.sounds_definitions:
                SoundsDefinitions.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture:
                Texture.Diagnose(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_flipbook_atlas:
                Flipbook.DiagnoseFlipbook(diagnoser);
                break;
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_item_atlas:
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.texture_terrain_atlas:
                TextureAtlas.DiagnoseAtlas(diagnoser);
                break;
            default:
            case bc_minecraft_bedrock_project_1.ResourcePack.FileType.unknown:
                return false;
        }
        return true;
    }
    ResourcePack.Process = Process;
})(ResourcePack || (exports.ResourcePack = ResourcePack = {}));
//# sourceMappingURL=ResourcePack.js.map