"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Diagnose = void 0;
const Types_1 = require("bc-minecraft-bedrock-project/lib/src/Lib/Internal/Types");
const Json_1 = require("../../Json/Json");
const Manifest_1 = require("../../Minecraft/Manifest");
/**Diagnoses the given document as an bp manifest
 * @param doc The text document to diagnose
 * @param diagnoser The diagnoser builder to receive the errors*/
function Diagnose(diagnoser) {
    const manifest = Json_1.Json.LoadReport(diagnoser);
    //check if manifest is valid
    if (!Json_1.Json.TypeCheck(manifest, diagnoser, "manifest", "minecraft.manifest.invalid", Types_1.Manifest.is))
        return;
    (0, Manifest_1.minecraft_manifest_diagnose)(manifest, diagnoser);
    (0, Manifest_1.minecraft_manifest_required_module)(manifest, diagnoser, "skin_pack");
}
exports.Diagnose = Diagnose;
//# sourceMappingURL=entry.js.map