"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.components_check = exports.component_warning = exports.component_error = void 0;
const Types_1 = require("../../Types");
function component_error(message, code) {
    return (name, component, context, diagnoser) => {
        diagnoser.add(name, message, Types_1.DiagnosticSeverity.error, code);
    };
}
exports.component_error = component_error;
function component_warning(message, code) {
    return (name, component, context, diagnoser) => {
        diagnoser.add(name, message, Types_1.DiagnosticSeverity.warning, code);
    };
}
exports.component_warning = component_warning;
function components_check(data, context, diagnoser, component_test) {
    if (data === undefined)
        return;
    compContainerCheck(data.components, context, diagnoser, component_test);
    if (data.component_groups) {
        Object.entries(data.component_groups).forEach(([key, group]) => {
            compContainerCheck(group, context, diagnoser, component_test);
        });
    }
}
exports.components_check = components_check;
function compContainerCheck(container, context, diagnoser, component_test) {
    if (container === undefined)
        return;
    const keys = Object.getOwnPropertyNames(container);
    keys.forEach((key) => {
        const callbackfn = component_test[key];
        if (callbackfn) {
            callbackfn(key, container[key], context, diagnoser);
        }
    });
}
//# sourceMappingURL=checks.js.map